/* fetch and call objects in modules */

#include <Python.h>    /* standard API def */
#include "Python_Compression.hh"

namespace Python__Compression
{



OCTETSTRING  f__compress(const CHARSTRING& pl__string) {
  

    int cstrLen = strlen(pl__string);
    const char *cstr = pl__string;; 
    PyObject *pstr, *pmod, *pfunc, *pargs;
     /* Initialize the Python Interpreter */
    Py_Initialize();    
    PyRun_SimpleString("import sys");
    /* export PYTHONPATH=.  */
    PyRun_SimpleString("sys.path.append('.')");      

    /* import module compression */
    pmod  = PyImport_ImportModule("compression");

    /* call compression.compress() */
    pfunc = PyObject_GetAttrString(pmod, "compress");
    pargs = Py_BuildValue("(s)", cstr);

    pstr  = PyEval_CallObject(pfunc, pargs);
    PyArg_Parse(pstr, "s#", &cstr,&cstrLen);

    
    OCTETSTRING  ret_val(cstrLen, (const unsigned char *)cstr);
    
    /* free owned objects */
    Py_DECREF(pmod);
    Py_DECREF(pstr);
    Py_DECREF(pfunc);        /* not really needed here  */
    Py_DECREF(pargs);        /* since all memory goes away  */
    
     /* Finish the Python Interpreter */
    
    Py_Finalize();
    
    return ret_val;
    
}


CHARSTRING  f__uncompress(const OCTETSTRING& pl__string) {
  
  
    PyObject *pstr, *pmod, *pfunc, *pargs;
     /* Initialize the Python Interpreter */
    Py_Initialize();    
    PyRun_SimpleString("import sys");
    /* export PYTHONPATH=.  */
    PyRun_SimpleString("sys.path.append('.')");      
        
 
    int cstrLen = pl__string.lengthof();
    const unsigned char *ostr = pl__string; 
    const char *cstr = (const char *)ostr;
    

    /* import module compression */
    pmod  = PyImport_ImportModule("compression");

    /* call compression.decompress() */
    pfunc = PyObject_GetAttrString(pmod, "decompress");
    pargs = Py_BuildValue("(s#)", cstr,cstrLen);

    pstr  = PyEval_CallObject(pfunc, pargs);
    if (! PyArg_Parse(pstr, "s", &cstr)) return "";

    
    CHARSTRING  ret_val(cstr);
    
    /* free owned objects */
    Py_DECREF(pmod);
    Py_DECREF(pstr);
    Py_DECREF(pfunc);        /* not really needed here      */
    Py_DECREF(pargs);        /* since all memory goes away  */
    
     /* Finish the Python Interpreter */
    
    Py_Finalize();
    
    return ret_val;
    
}



}
